using System;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            String[] s = Console.ReadLine().Split();
            int o = int.Parse(s[0]);
            int a = int.Parse(s[1]);
            int b = int.Parse(s[2]);
            int ab = int.Parse(s[3]);
            string[] niz = new string[n]; 
            bool moze = true;
            for (int i = 0; i < n; i++)
            {
                String[] k = Console.ReadLine().Split();
                string grupa = k[0];
                int broj = int.Parse(k[1]);
                int[] niz1 = new int[4];
                if (grupa == "O" && moze)
                {
                    if (o >= broj)
                    {
                        o = o - broj;
                        niz1[0] = broj;
                    }
                    else
                    {
                        moze = false;
                    }
                }
                else if (grupa == "A" && moze)
                {
                    if (a >= broj)
                    {
                        a = a - broj;
                        niz1[1] = broj;
                    }
                    else
                    {
                        niz1[1] = a;
                        int ostalo = broj - a;
                        a = 0;
                        if (o >= ostalo)
                        {
                            o = o - ostalo;
                            niz1[0] = ostalo;
                        }
                        else
                        {
                            moze = false;
                        }
                    }
                }
                else if (grupa == "B" && moze)
                {
                    if (b >= broj)
                    {
                        b = b - broj;
                        niz1[2] = broj;
                    }
                    else
                    {
                        niz1[2] = b;
                        int ostalo = broj - b;
                        b = 0;
                        if (o >= ostalo)
                        {
                            o = o - ostalo;
                            niz1[0] = ostalo;
                        }
                        else
                        {
                            moze = false;
                        }
                    }
                }
                else 
                {
                    if (ab >= broj)
                    {
                        ab = ab - broj;
                        niz1[3] = broj;
                    }
                    else
                    {
                        niz1[3] = ab;
                        int ostalo = broj - ab;
                        ab = 0;
                        if (a >= ostalo)
                        {
                            a = a - ostalo;
                            niz1[1] = ostalo;
                        }
                        else
                        {
                            niz1[1] = a;
                            ostalo = ostalo - a;
                            a = 0;
                            if (b >= ostalo)
                            {
                                b = b - ostalo;
                                niz1[2] = ostalo;
                            }
                            else
                            {
                                niz1[2] = b;
                                ostalo = ostalo - b;
                                b = 0;
                                if (o >= ostalo)
                                {
                                    o = o - ostalo;
                                    niz1[0] = ostalo;
                                }
                                else
                                {
                                    moze = false;
                                }
                            }
                        }
                    }
                }
                niz[i] = niz1[0] + " " + niz1[1] + " " + niz1[2] + " " + niz1[3];
            }
            if (moze)
            {
                Console.WriteLine("moguce");
                for (int i = 0; i < n; i++)
                    Console.WriteLine(niz[i]);
            }
            else
                Console.WriteLine("nemoguce");
        }
    }
}